<?php

namespace STM\DB\SQL;

/**
 * Test class for UpdateQuery.
 * Generated by PHPUnit on 2012-02-06 at 13:55:22.
 * @group database
 */
class UpdateQueryTest extends \PHPUnit_Framework_TestCase {

    /** @var UpdateQuery */
    protected $object;

    protected function setUp() {
        $this->object = new UpdateQuery(DT_COMPETITIONS);
    }

    public function testGenerate_AND_isValid() {
        // WHERE and SET attributes must be set (and table must be nonempty string)
        parent::assertFalse($this->object->generate());
        parent::assertFalse($this->object->isValid());
        
        $this->object->addAttributes(array('key' => 2));
        parent::assertFalse($this->object->generate());
        parent::assertFalse($this->object->isValid());
        
        $this->object->setWhere(new Condition('key = 2'));
        parent::assertTrue(is_string($this->object->generate()));
        parent::assertTrue($this->object->isValid());
        
        $query = new UpdateQuery('');
        $query->addAttributes(array('key' => 2));
        $query->setWhere(new Condition('key = 2'));
        parent::assertFalse($query->isValid());
        parent::assertFalse($query->generate());
    }

    public function testSet_attributes() {
        $this->object->setWhere(new Condition('key = 2'));//if where is not set, then it cannot be valid
        
        // must be array with scalar keys and values                
        $this->object->addAttributes(null);
        parent::assertFalse($this->object->isValid());
        $this->object->addAttributes(array(1 => array()));
        parent::assertFalse($this->object->isValid());        
        $this->object->addAttributes(array('id' => null));
        parent::assertFalse($this->object->isValid());
        
        $this->object->addAttributes(array('key' => 'value'));        
        parent::assertTrue($this->object->isValid());
    }

    public function testSet_where() {
        $this->object->addAttributes(array('key' => 'value'));
        
        // instance of Condition + valid
        $this->object->setWhere(new Condition(''));
        parent::assertFalse($this->object->isValid());                
        
        $this->object->setWhere(new Condition('key = {V}', array('V' => 1)));        
        parent::assertTrue($this->object->isValid());
    }

}

?>
